package LATMOS::Accounts::Web::Controller::Json::Stat;
use Moose;
use namespace::autoclean;

BEGIN { extends 'Catalyst::Controller'; }

=head1 NAME

LATMOS::Accounts::Web::Controller::Json::Stat - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

sub index :Path :Args(1) {
    my ( $self, $c, $statname ) = @_;

    my $base = $c->model('Accounts')->db;

    my $ostat = $base->get_object('stat', $statname) or return;

    my $res = $ostat->getStat or return;

    $c->stash->{data} = [ map { [ $_, $res->{$_} +0 ] } sort { $res->{$b} <=> $res->{$a} } keys %$res ];
}

sub history :Local :Args(1) {
    my ( $self, $c, $statname ) = @_;

    my $base = $c->model('Accounts')->db;

    my $ostat = $base->get_object('stat', $statname) or return;

    my $data = $ostat->getAllStat or return;

    my $graph = {
        series => [],
        data => [],
    };

    my %lines;

    foreach my $date (sort keys %$data) {
        foreach my $val (sort keys %{ $data->{$date} }) {
            push(@{ $lines{$val} }, [ $date, $data->{$date}{$val} + 0 ]);
        }
    }

    foreach (sort keys %lines) {
        push(@{ $graph->{data} }, $lines{$_});
        push(@{ $graph->{series} }, { label => $_ });
    }

    $c->stash->{data} = $graph;
}


=encoding utf8

=head1 AUTHOR

Olivier Thauvin

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
